# -*- coding: utf-8 -*-
# Algorithmus-von-Prim-original-mit-Ausgaben.py

# Graph von Turau:
mustergraph={ 1: [[2,4],[6,10], [7,5]],
              2: [[1,4],[3,7],[7,2]],
              3: [[2,7],[4,12],[7,1]],
              4: [[3,12],[5,4]],
              5: [[4,4],[6,3],[7,8]],
              6: [[1,10],[5,3],[7,4],[7,4]],
              7: [[1,5],[2,2],[6,4],[3,1],[5,8],[6,4]]}

# ----- kuerzer -----
def kuerzer(kante1, kante2):
    return  (kante1[2] < kante2[2])

# ----- ordneEin -----
# sortiert durch Einfügen
def ordneEin(kante, sortierte):
    for index in range(len(sortierte)):
        if kuerzer(kante, sortierte[index]):
            sortierte[index:index]=[kante]
            return sortierte
    sortierte[len(sortierte):len(sortierte)]=[kante]
    return sortierte

def nachfolgeKanten(knoten, graph):
    kanten=[]
    nachfolger=graph[knoten]
    for nach in nachfolger:
        kanten+=[[knoten]+nach]
    return kanten

# ----- Der eigentliche Algorithmus -----
# Aufrufhülle für die Rekursion
def AvPrim(graph, startKnoten):
    baum=[]
    enthalteneKnoten=[startKnoten]
    neuerKnoten=startKnoten
    prioSchlange=[]
    while len(enthalteneKnoten)<len(graph):
        print( '\nDer Baum ist bisher:', baum )
        print( 'PrioSchlange ist jetzt:', prioSchlange )
        print( 'Neuer Knoten ist:', neuerKnoten )
        nachF=nachfolgeKanten(neuerKnoten, graph)
        print( 'Nachfolge-Kanten sind:', nachF )
        for kante in nachF:
            print( 'bearbeite Kante:', kante )
            prioSchlange=ordneEin(kante, prioSchlange)
            print( 'PrioSchlange ist jetzt:', prioSchlange )
        # Entferne alle Zyklen:
        temp=[]
        for kante in prioSchlange:
            print( 'Zyklentest der Kante', kante )
            if not (kante[0] in enthalteneKnoten):
                temp.append(kante)
            elif not (kante[1] in enthalteneKnoten):
                temp.append(kante)
            else:
                # kante bildet Zyklus
                print( 'Sie erzeugt einen Zyklus' )
        prioSchlange=temp
        print( 'PrioSchlange ist nach der Bereinigung:', prioSchlange )
        # Die erste Kante setzt den Baum minimal fort
        print( 'Die erste Kante kann eingebaut werden:',prioSchlange[0] )
        baum.append(prioSchlange[0])
        if prioSchlange[0][0] in enthalteneKnoten:
            enthalteneKnoten.append(prioSchlange[0][1])
            neuerKnoten=prioSchlange[0][1]
        else:
            enthalteneKnoten.append(prioSchlange[0][0])
            neuerKnoten=prioSchlange[0][0]
        prioSchlange.remove(prioSchlange[0])
    return baum


### ===== Testaufruf =====
print( AvPrim(mustergraph, 1) )
